﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Hosting;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System.IO;
using Syncfusion.Pdf.Tables;
using Syncfusion.Pdf.Grid;
using Syncfusion.Drawing;

namespace WebApplication.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment _hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            _hostingEnvironment = hostingEnvironment;
        }
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult GeneratePDF()
        {
           
            //Create a new PDF document
            PdfDocument document = new PdfDocument();

            //Add a page to the document.
            PdfPage page = document.Pages.Add();

            ////Create PDF graphics for the page.
            PdfGraphics graphics = page.Graphics;

        
            PdfGrid pdfGrid = new PdfGrid();
            pdfGrid.Columns.Add(3);

            //Add header.

            pdfGrid.Headers.Add(1);

            PdfGridRow pdfGridHeader = pdfGrid.Headers[0];

            pdfGridHeader.Cells[0].Value = "Employee ID";

            pdfGridHeader.Cells[1].Value = "Employee Name";

            pdfGridHeader.Cells[2].Value = "Salary";

            //Add rows.
            for(int i = 0; i < 5; i++)
            {
                PdfGridRow pdfGridRow = pdfGrid.Rows.Add();

                pdfGridRow.Cells[0].Value = "E01";

                pdfGridRow.Cells[1].Value = "Clay";

                pdfGridRow.Cells[2].Value = "$10,000";
            }
           

            //Draw the PdfGrid.

            pdfGrid.Draw(page, PointF.Empty);


            //Saving the PDF to the MemoryStream
            MemoryStream ms = new MemoryStream();

            document.Save(ms);

            //If the position is not set to '0' then the PDF will be empty.
            ms.Position = 0;

            //Download the PDF document in the browser.
            FileStreamResult fileStreamResult = new FileStreamResult(ms, "application/pdf");
            fileStreamResult.FileDownloadName = "Sample.pdf";
            return fileStreamResult;

           
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
